<?php

function bingtranslate ($text, $from, $to, $clientID, $clientSecret)
{
    include_once 'HttpTranslator.php';
    include_once 'AccessTokenAuthentication.php';

    try {
       
        //OAuth Url.
        $authUrl      = "https://datamarket.accesscontrol.windows.net/v2/OAuth2-13/";
        //Application Scope Url
        $scopeUrl     = "http://api.microsofttranslator.com";
        //Application grant type
        $grantType    = "client_credentials";

        //Create the AccessTokenAuthentication object.
        $authObj      = new AccessTokenAuthentication();
        
        //Get the Access token.
        $accessToken  = $authObj->getTokens($grantType, $scopeUrl, $clientID, $clientSecret, $authUrl);
        //Create the authorization Header string.
        $authHeader = "Authorization: Bearer ". $accessToken;

        //Set the params.//
        $fromLanguage = $from;
        $toLanguage   = $to;
        $inputStr     =  $text;
        $contentType  = 'text/plain';
        $category     = 'general';
    
        $params = "text=".urlencode($inputStr)."&to=".$toLanguage."&from=".$fromLanguage;
        $translateUrl = "http://api.microsofttranslator.com/v2/Http.svc/Translate?$params";
    
        //Create the Translator Object.
        
        $translatorObj = new HTTPTranslator();
        
    
        //Get the curlResponse.
        $curlResponse = $translatorObj->curlRequest($translateUrl, $authHeader);
    
        //Interprets a string of XML into an object.
        $xmlObj = simplexml_load_string($curlResponse);
        //echo $curlResponse;
        foreach((array)$xmlObj[0] as $val){
            $translatedStr = $val;
        }
        //$translatorObj = null;
        return "".$translatedStr."";

    } catch (Exception $e) {
        echo "Exception: " . $e->getMessage() . PHP_EOL;
        return null;
    }
}

//echo translate("<b>Hello</b>hello<pre>hello, how are you</pre>hello how are you ?", "en", "fr");

?>
