<?php
   
  function BuildHistoryTable()
  {
  	global $wpdb; 
  	//$wpdb->query("DROP TABLE IF EXISTS {$wpdb->prefix}traducpost_history"); 
  	$sql1 = "CREATE TABLE IF NOT EXISTS {$wpdb->prefix}importpost_history ( 
                id int(11) NOT NULL AUTO_INCREMENT, 
                origin_title varchar(255) NOT NULL,
                origin_url varchar(255) NOT NULL, 
                id_post int(11),
                code_post varchar(2),
                source_translate varchar(2),
                target_translate varchar(2),
                created_date DATETIME,
                updated_date DATETIME,
                status int(11) NOT NULL, PRIMARY KEY  (id) ) 
  				      ENGINE=InnoDB AUTO_INCREMENT=1;"; 
  	require_once(ABSPATH . 'wp-admin/includes/upgrade.php'); 
  	dbDelta($sql1); 
  	$sql2 = "CREATE TABLE IF NOT EXISTS {$wpdb->prefix}importpost_lastchoice (                 
                translate BOOLEAN,
                source_language varchar(2),
                target_language varchar(2),                                 
                updated_date DATETIME )                 
  				      ENGINE=InnoDB AUTO_INCREMENT=1;";   	
  	dbDelta($sql2); 
  	InsertDefaultChoice();
  } 
 
 
  function InsertDefaultChoice()
  {
    global $wpdb;
    $sql1 = "DELETE FROM {$wpdb->prefix}importpost_lastchoice;";
    $wpdb->query($wpdb->prepare($sql1));
    
    $sql1 = "INSERT INTO {$wpdb->prefix}importpost_lastchoice 
        (translate, source_language, target_language, updated_date) 
        Values (%s, %s, %s, Now());";
    $wpdb->query($wpdb->prepare($sql1, 0, "", ""));
  }
 
  function GetDefaultChoice()
  {   
    global $wpdb; 
    $rows = $wpdb->get_results( 
                  	"
                  	SELECT translate, source_language, target_language  
                  	FROM {$wpdb->prefix}importpost_lastchoice                     
                  	"
                    );
    return $rows;
  }
 
  function UpdateChoice($isTranslate, $source_language, $target_language)
  {
    global $wpdb;
    $sql1 = "UPDATE INTO {$wpdb->prefix}importpost_lastchoice 
        (translate, source_language, target_language, updated_date) 
        Values (%s, %s, %s, Now());";
    $wpdb->query($wpdb->prepare($sql1, "false", "", ""));
  }
 
 
  function InsertPostInHistory($title, $url, $id_post, $code_post, $source_translate, $target_translate)
  {
    //echo "build table";
    BuildHistoryTable();
    global $wpdb;
    $sql1 = "INSERT INTO {$wpdb->prefix}importpost_history 
        (origin_title, origin_url, id_post, code_post, source_translate, target_translate, created_date) 
        Values (%s, %s, %s, %s, %s, %s, Now());";
    $wpdb->query($wpdb->prepare($sql1, $title, $url, $id_post, $code_post, $source_translate, $target_translate));
  }
  
  
  function PurgeHistory()
  {
    global $wpdb; 
    $sql1 = "DELETE FROM {$wpdb->prefix}importpost_history 
         WHERE id_post NOT IN (SELECT ID FROM {$wpdb->prefix}posts)";
    $wpdb->query($wpdb->prepare($sql1));
  }
  
  
  function SelectHistoryPage($p)
  {
    $limit = "LIMIT " . ($p->page - 1) * $p->limit  . ", " . $p->limit;
    global $wpdb; 
    $rows = $wpdb->get_results( 
                  	"
                  	SELECT origin_title, origin_url, id, created_date  
                  	FROM {$wpdb->prefix}importpost_history 
                    ORDER BY created_date DESC
                    $limit
                  	"
                    );
    return $rows;
  }
  
  function PageHistory()
  {
       PurgeHistory();
       global $wpdb; 
       require_once(ABSPATH . 'wp-content/plugins/importyourpost/pagination.class.php'); 
       $sql = "SELECT origin_title, origin_url, id 
               FROM {$wpdb->prefix}importpost_history";
       
       
       $items = mysql_num_rows(mysql_query($sql)); // number of total rows in the database
 
      if($items > 0) {
        $p = new pagination;
        $p->items($items);
        $p->limit(10); // Limit entries per page
        $p->target("options-general.php?page=wp_plugin_ImportYourPost_addPosts&update=1"); 
        $p->currentPage($_GET[$p->paging]); // Gets and validates the current page
        $p->calculate(); // Calculates what to show
        $p->parameterName('paging');
        $p->adjacents(1); //No. of page away from the current page
                 
        if(!isset($_GET['paging'])) {
            $p->page = 1;
        } else {
            $p->page = $_GET['paging'];
        }
        return $p; 
        //Query for limit paging
     //   $limit = "LIMIT " . ($p->page - 1) * $p->limit  . ", " . $p->limit;
         
      } else 
      {
          echo "No Record Found";
      }
  }
 
?>