<?php
/*
Plugin Name: ImportYourPost (IYP)
Plugin URI: http://www.bratched.com
Description: With this plugin, you can import and auto traduct single post (with bing translator).This plugin can import item from Wordpress or Joomla sites. You can also import HTML directly.The items with source code are managed properly and images are directly imported into the media library. Article becomes identical to a directly entered in Article Wordpress interface. Works in multi sites. 
Version: 1.0
Author: Bratched
Author URI: http://www.bratched.com
License: GPL2
*/
   
/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/
   
   if(!class_exists('WP_Plugin_ImportYourPost')) 
   { 
      class WP_Plugin_ImportYourPost 
      {
        /** 
         *        Construct the plugin object 
         */ 
        public function admin_init() 
        {
          $this->init_settings();
        }
        
        public function init_settings() 
        { 
          register_setting('wp_plugin_template-group', 'settingsClientID'); 
          register_setting('wp_plugin_template-group', 'settingsClientSecret');                     
        } 


        public function add_menu() 
        { 
          
          add_options_page('WP Plugin Template Settings',  __('IYP-Settings', 'importyourpost')
            , 'manage_options', 'wp_plugin_ImportYourPost_settings'
            , array(&$this, 'plugin_settings_page')); 
           
          add_management_page( 'WP Plugin Template Settings 2', __('IYP-Import', 'importyourpost'),
          'manage_options', 'wp_plugin_ImportYourPost_addPosts',  array(&$this, 'plugin_addPosts_page'));
        }
        
        
        public function plugin_settings_page() 
        { 
            if(!current_user_can('manage_options')) 
            { 
              wp_die(__('You do not have sufficient permissions to access this page.')); 
            } 
            include(sprintf("%s/settings.php", dirname(__FILE__))); 
        } 
        
        public function plugin_addPosts_page() 
        { 
            if(!current_user_can('manage_options')) 
            { 
              wp_die(__('You do not have sufficient permissions to access this page.')); 
            } 
            include(sprintf("%s/addPosts.php", dirname(__FILE__))); 
        } 
        

        function liste_plugin_load_text_domain() {
          $path = dirname(plugin_basename(__FILE__)) . '/languages/';
          load_plugin_textdomain('importyourpost', false, $path);
        }

        
        public function __construct() 
        {
          add_action('admin_init', array(&$this, 'admin_init')); 
          add_action('admin_menu', array(&$this, 'add_menu'));                        
          add_action('init', array(&$this, 'liste_plugin_load_text_domain'));

        } 
          
        /** 
         * Activate the plugin 
         */ 
        public static function activate() 
        {
            
             require_once(ABSPATH . 'wp-content/plugins/importyourpost/historypost.php');
             BuildHistoryTable();
             
          // Do nothing 
        } // END public static function activate
         
        /** 
        *          Deactivate the plugin 
        */ 
        public static function deactivate() 
        { 
          // Do nothing 
        } // END public static function deactivate 
      }  // END class WP_Plugin_Template 
    } // END if(!class_exists('WP_Plugin_Template'))   
   
   
   if(class_exists('WP_Plugin_ImportYourPost')) 
   {
         // Installation and uninstallation hooks 
    register_activation_hook(__FILE__, array('WP_Plugin_ImportYourPost', 'activate')); 
    register_deactivation_hook(__FILE__, array('WP_Plugin_ImportYourPost', 'deactivate'));  
    $wp_plugin_template = new WP_Plugin_ImportYourPost();
     
    if(isset($wp_plugin_template))
    {
    // Add the settings link to the plugins page
      function plugin_settings_link($links)
      { 
          $settings_link = '<a href="options-general.php?page=wp_plugin_ImportYourPost_settings">Settings</a>'; 
          array_unshift($links, $settings_link); 
          return $links; 
      }

      
      $plugin = plugin_basename(__FILE__); 
      add_filter("plugin_action_links_$plugin", 'plugin_settings_link');
    }
     
   }
?>