<?php
if(!current_user_can('manage_options')) 
{ 
  wp_die(__('You do not have sufficient permissions to access this page.')); 
} 
?>

<?php

function showMessage($message, $errormsg = false)
{
	if ($errormsg) {
		echo '<div id="message" class="error">';
	}
	else {
		echo '<div id="message" class="updated fade">';
	}
	echo "<p><strong>$message</strong></p></div>";
}    



  function FormatPreTag($element)
  {
      $parent = $element->parent();
      $element = PurgeSpan($element);
      $contentpre = $element->innertext;
      $textarea = $element->find('textarea', 0);
      if (isset($textarea))
      {
        $textarea = PurgeSpan($textarea);
        $contentpre = $textarea->innertext;
      }     
      $contentpre = PurgeBR($contentpre);
      $contentpre  = str_replace("&gt;", '>', $contentpre);
      $contentpre  = str_replace("&lt;", '<', $contentpre);
      $contentpre  = str_replace("&amp;gt;", '&gt;', $contentpre);
      $contentpre  = str_replace("&amp;lt;", '&lt;', $contentpre);
      $parent->outertext = "<span class=\"notranslate\"><pre>".$contentpre."</pre></span>";
  }

  function PurgeBR($text)
  {
     $result = str_replace("<br />", "<br/>", $text);
     $result = str_replace("<br/>", "\r\n", $result);
     return $result;
  }
  
  function PurgeSpan($element)
  {
      foreach($element->find('span') as $span) 
      {
          $span->outertext = $span->innertext;    
      }
      return $element;
  }    
  
  function PurgeCrayonHighlight($html)
  {
    foreach($html->find('pre') as $element) 
    {
       FormatPreTag($element);
    }

    foreach($html->find('div[class=crayon-toolbar]') as $element) 
    {
      $element->outertext = "";
    }
    foreach($html->find('div[class=crayon-info]') as $element) 
    {
      $element->outertext = "";
    }

    foreach($html->find('div[class=crayon-plain-wrap]') as $element) 
    {
      FormatPreTag($element);
    }

    return $html;
  }
  
  
  function StartsWith($Haystack, $Needle)
  {
    return strpos($Haystack, $Needle) === 0;
  }
  
  function LinkFormat($url, $rootSource)
  {
     if (StartsWith($url, '/'))
     {
       return $rootSource.$url; 
     }
     else
     {
       return $url; 
     }
  }
  
  function ImportMedias($elems, $rootSource, &$medias)
  {
   // to disable uncomment - return $elems;
    
    foreach($elems->find('img') as $img) 
    {
      if(isset($img->src))
      {
        $oldsrc = LinkFormat($img->src, $rootSource);        
        $mediaData = fetch_media($oldsrc, "");        
        if (isset($mediaData))
        {
          $media = $mediaData['guid'];  
          $medias[] = $mediaData;
          $img->src=$media;
          $a = $img->parent;
          if(isset($a->href))
          {
            $hrefurl = LinkFormat($a->href, $rootSource);
            $ext = array_pop(explode(".", $hrefurl));
            if ($oldsrc !== $hrefurl && ($ext==="jpg" || $ext==="gif"))
            {
                $mediaData = fetch_media($hrefurl, "");
                if (isset($mediaData))
                {
                  $media = $mediaData['guid']; 
                  $medias[] = $mediaData;
                  $a->href=$media;
                }
            }
          }
        }
      }
    }
    
    return $elems;
  }
   
   
  function TransformBody($html, $typesource)
  {
    switch($typesource)
    {
      case 'WP' :
         return $html->find('div[class=entry-content]', 0);
         break;
      case 'JM' :
         return $html->find('div[class=article-content]', 0);
         break;
      case 'OT' :
         return $html;
         break;
      default :
         return "";
    }
  }
  
  function TransformTitle($html, $typesource)
  {
    switch($typesource)
    {
      case 'WP' :
         return $html->find('h1[class=entry-title]', 0);
         break;
      case 'JM' :
         return $html->find('h2[class=contentheading]', 0);
         break;
      case 'OT' :
         return $html->find('h1', 0);
         break;
      default :
         return "";
    }
  }
  

  // find Tags in WP or Joomla Posts
  function TransformTags($html, $typesource)
  {
    switch($typesource)
    {
      case 'WP' :
         $footer = $html->find('footer[class=entry-meta]', 0);
         $vals = array();
         if (isset($footer))
         {
           foreach($footer->find('a[rel=tag]') as $val)
           {
              $vals[]=trim($val->innertext);
           }
         }
         return $vals;
         break;

      case 'JM' :             
         $vals = array();
         foreach($html->find('a[rel=tag]') as $val)
         {
            $vals[]=trim($val->innertext);
         }         
         return $vals;
         break;

      default :
         return null;
    }
  }
  
  // find Categories in WP or Joomla Posts
  function TransformCategories($html, $typesource)
  {    
    switch($typesource)
    {
      case 'WP' :
         $footer = $html->find('footer[class=entry-meta]', 0);
         $vals = array();
         if (isset($footer))
         {
           foreach($footer->find('a[rel=category]') as $val)
           {             
              $vals[]= get_cat_ID(trim($val->innertext));
           }
         }
         return $vals;
         break;

      case 'JM' :          
         $footer = $html->find('span[class=article-section]', 0);
         $vals = array();
         if (isset($footer))
         {
           foreach($footer->find('a') as $val)
           {            
              $vals[]= get_cat_ID(trim($val->innertext));
           }
         }
         return $vals;
         break;

      default :
         return null;
    }
  }
  
  // Transform Post
  function TransformPost($url, $textSource, $typesource, $isTranslate, $originTranslate, $targetTranslate)
  {
    
    set_time_limit(600);
    if (isset($textSource) && $textSource!=='')
    {
      $httpcontent = str_replace('\"', '"', $textSource);
      $textSource = str_replace("\'", "'", $textSource);                  
    }
    else
      $httpcontent = file_get_contents($url);
    
    //Test joomla
    //    $httpcontent  = file_get_contents(ABSPATH.'/wp-content/plugins/importyourpost/testJmla.txt');
    //trace content
    //    file_put_contents("testcontent.txt", $httpcontent, LOCK_EX);
    //
  	if ($httpcontent != false) // no error, new content
  	{
  	   require_once(ABSPATH . 'wp-content/plugins/importyourpost/simple_html_dom.php');
       require_once(ABSPATH . 'wp-content/plugins/importyourpost/bingtranslator.php');       
       $html = str_get_html($httpcontent, false, true, DEFAULT_TARGET_CHARSET, false, DEFAULT_BR_TEXT, DEFAULT_SPAN_TEXT);
       
       $rootSource = "";       
       $urlexplode = explode("//", $url);
       if (count($urlexplode)> 1)
       {
          $protocoleSource = $urlexplode[0];          
          $endUrlexplode =  explode("/", $urlexplode[1]);
          if (count($endUrlexplode)>0)
          {
             $rootSource = $protocoleSource."//".$endUrlexplode[0];
          }
       }

       $medias = array();
       $html = PurgeCrayonHighlight($html);
       $elems = TransformBody($html, $typesource);
       
       if (isset($elems)) 
       {
         $elems = ImportMedias($elems, $rootSource, $medias);
         if (isset($elems))
         {
            $nicehtml2 = $elems->innertext;
            if ($isTranslate)
            {
                $nicehtml2 = bingtranslate($nicehtml2, $originTranslate, $targetTranslate, get_option('settingsClientID'), get_option('settingsClientSecret'));
            }
          }
       }
       else
       {
           $nicehtml2 = "";
           showMessage(__('Be Carrefull, content post not found','importyourpost'), false);
           
       }
       
       //file_put_contents("testcontent.txt", $nicehtml2, LOCK_EX);
       
       $elemTitle = TransformTitle($html, $typesource);
       if (isset($elemTitle))
       { 
          $nicetitle = $elemTitle->plaintext;
          if ($isTranslate)
          {
            $nicetitle = bingtranslate($nicetitle, $originTranslate, $targetTranslate, get_option('settingsClientID'), get_option('settingsClientSecret'));
          }
       }
       else
       {
          $nicetitle = "";
       }

       if (strlen($nicehtml2) <= 0 && strlen($nicetitle) <= 0)
       {
          return null;
       }
       else
       {

          $my_post = array(
            'post_title'    => $nicetitle,
            'post_content'  => $nicehtml2,
            'post_status'   => 'publish',
            'post_author'   => 1,
            'post_category' => TransformCategories($html, $typesource),
            'tags_input' => TransformTags($html, $typesource)
          );
          
            // Insert the post into the database
            $idPost = wp_insert_post($my_post);
            UpdateMediaWithPost($idPost, $medias);
            $datareturn = array(
              'post_title'    => $nicetitle,
              'id_post' => $idPost,
              'nbMedia' => count($medias));
            
            return $datareturn;
        }
      }
      else return null;
 
  }

  function UpdateMediaWithPost($post_id, $medias)
  {
    global $wpdb;
    $artDir = "/importedmedia/";
    $uploads = wp_upload_dir();
    foreach($medias as $artdata)
    {    
        $artdata['post_parent'] = $post_id;
		    $save_path =  $uploads['basedir'].$artDir.$artdata['post_title'];
		   //insert the database record
		    $attach_id = wp_insert_attachment( $artdata, $save_path, $post_id);//$post_id );
		  //generate metadata and thumbnails
		    if ($attach_data = wp_generate_attachment_metadata( $attach_id, $save_path)) 
        {
		      wp_update_attachment_metadata($attach_id, $attach_data);
		     }
    }
  }
  
  function fetch_media($file_url, $post_id) 
  {
  	require_once(ABSPATH . 'wp-load.php');
  	require_once(ABSPATH . 'wp-admin/includes/image.php');
  	global $wpdb;
  	$artDir = '/importedmedia/';
  	$uploads = wp_upload_dir();
  	
  	//if the directory doesn't exist, create it	
  	if(!file_exists($uploads['basedir'].$artDir)) 
    {
  		mkdir($uploads['basedir'].$artDir);
  	}
  	$ext = array_pop(explode(".", $file_url));
    $showID = array_pop(explode("/", $file_url));
  	$new_filename = 'blogmedia-'.$showID;
  	$new_filename = sanitize_title_with_dashes(str_replace("_", "-", $new_filename)).".".$ext;
    //echo $new_filename;
  	if (@fclose(@fopen($file_url, "r"))) { //make sure the file actually exists
  		copy($file_url, $uploads['basedir'].$artDir.$new_filename);
  		$siteurl = get_option('siteurl');
  		$file_info = getimagesize($uploads['basedir'].$artDir.$new_filename);

  		//create an array of attachment data to insert into wp_posts table
  		$artdata = array();
  		$artdata = array(
  			'post_author' => 1, 
  			'post_date' => current_time('mysql'),
  			'post_date_gmt' => current_time('mysql', 1),
  			'post_title' => $new_filename, 
  			'post_status' => 'inherit',
  			'comment_status' => 'closed',
  			'ping_status' => 'closed',
  			'post_name' => $new_filename,
        'post_modified' => current_time('mysql'),
  			'post_modified_gmt' => current_time('mysql', 1),
  			'post_parent' => $post_id,
  			'post_type' => 'attachment',
  			'guid' => $uploads['baseurl'].$artDir.$new_filename,
  			'post_mime_type' => $file_info['mime'],
  			'post_excerpt' => '',
  			'post_content' => ''
  		);
  	}
  	else {
  		return null;
  	}
  	return $artdata; 
  }

?>